using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

using ArtOfTest.Common.UnitTesting;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.Controls.HtmlControls;
using ArtOfTest.WebAii.Controls.HtmlControls.HtmlAsserts;
using ArtOfTest.WebAii.Design;
using ArtOfTest.WebAii.Design.Execution;
using ArtOfTest.WebAii.ObjectModel;
using ArtOfTest.WebAii.Silverlight;
using ArtOfTest.WebAii.Silverlight.UI;
using ArtOfTest.WebAii.Wpf;
using Telerik.WebAii.Controls.Xaml.Wpf;
using System.Threading;
namespace TestStudioProject6
{
	//
	// You can add custom execution steps by simply
	// adding a void function and decorating it with the [CodedStep] 
	// attribute to the test method. 
	// Those steps will automatically show up in the test steps on save.
	//
	// The BaseWebAiiTest exposes all key objects that you can use
	// to access the current testcase context. [i.e. ActiveBrowser, Find ..etc]
	//
	// Data driven tests can use the Data[columnIndex] or Data["columnName"] 
	// to access data for a specific data iteration.
	//
	// Example:
	//
	// [CodedStep("MyCustom Step Description")]
	// public void MyCustomStep()
	// {
	//		// Custom code goes here
	//      Applications.Spreadsheetexe.Book1__Spreadsheet.InsertTabitem.User.Click();	
	// }
	//
		

    public class WpfTest1 : BaseWebAiiTest
    {
        private const string WarnungOk = "OK";
        private const string Open = "Offnen";
        private const string NotOpen = "Nicht geffnet.";
        private const string KassaffnenOpenstation = "OpenStation";
        private const string StatusAsOpen = "Offnen";
        private const string KassaffnenmitGenehmigungUsername = "UserName";
        private const string KassaffnenmitGenehmigungPassword = "Password";
        private const string KassaffnenmitGenehmigungLogin = "Login";
        #region [ Dynamic Applications Reference ]

        private Applications _applications;

        /// <summary>
        /// Gets the Applications object that has references
        /// to all the elements, windows or regions
        /// in this project.
        /// </summary>
		public Applications Applications
		{
			get
			{
				if (_applications == null)
				{
					_applications = new Applications(Manager.Current);
				}
				return _applications;
			}
        }

        #endregion

        [CodedStep(@"New Coded Step")]
        public void WpfTest1_CodedStep() {
            ActiveApplication.Quit();
            WpfApplication wpfApp = Manager.LaunchNewApplication(@"E:\Builds\Build_29August2014\Bin\CARA.Desktop.exe");
            wpfApp.GetWindow("Warnung").Find.ByName<Button>(WarnungOk).User.Click();
            Thread.Sleep(1000);
            Assert.IsTrue(wpfApp.MainWindow.Window.Caption != null);
            var row = wpfApp.MainWindow.Find.ByName<DataGrid>("Stations");
            var rows = row.RowElements;
            var alreadyopenstation = rows.FirstOrDefault(stationRow => stationRow.TextBlockContent.Contains(Environment.MachineName));
            var openstation = rows.FirstOrDefault(stationRow => stationRow.TextBlockContent.Contains(Open));
            var notopenstation = rows.FirstOrDefault(stationRow => stationRow.TextBlockContent.Contains(NotOpen));

            System.DateTime today = System.DateTime.Now;
            System.DateTime date = today.AddYears(-30);

            if (alreadyopenstation != null || openstation != null || notopenstation != null)
            {
                wpfApp.MainWindow.Find.ByName<Button>(KassaffnenOpenstation).User.Click();
                Thread.Sleep(1000);

                wpfApp.GetWindow("Warnung").Find.ByAutomationId("btnOk").User.Click();
                //  string window = wpfApp.MainWindow.Window.Caption;
                Assert.IsTrue(wpfApp.MainWindow.Window.Caption != null);


                wpfApp.MainWindow.Find.ByAutomationId("txtLastName").User.TypeText(("tom"), 1);
                wpfApp.MainWindow.Find.ByAutomationId("txtFirstName").User.TypeText(("rom"), 1);
                Thread.Sleep(1000);
                wpfApp.MainWindow.Find.ByAutomationId("txtFirstName").User.KeyPress(System.Windows.Forms.Keys.Enter, 1);
                wpfApp.MainWindow.Find.ByName<DatePickerTextBox>("PART_TextBox").User.TypeText((date.ToString("dd/MM/yyyy")), 1, true);
                wpfApp.MainWindow.Find.ByAutomationId("cbIsYearSearch").User.Click();
                wpfApp.MainWindow.Find.ByAutomationId("cbIsYearSearch").User.Click();
            }

            // Add your test methods here...
        }
        
		// Add your test methods here...
    }
}
